﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;
using Infragistics.Win;

namespace UltraTreeTest
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraTree1.Nodes[0].Nodes[0].Override.ColumnSet = ultraTree1.ColumnSettings.ColumnSets[0];
            ultraTree1.Nodes[0].Nodes[0].Cells[0].Value = "test1";
            ultraTree1.Nodes[0].Nodes[0].Cells[1].Value = "test2";
            ultraTree1.Nodes[0].Nodes[0].Cells[2].Value = @"Examination:1137421  US FOOT (TA &amp; PV)    1122882  US ANKLE GENERAL     1137277  ANKLE 2 VIEWS     1122885  BMD WRIST &amp; SPINE AP  Chest.  
There is evidence of reconstructive breast surgery.  No focal active lung lesion is seen.  Heart is not enlarged.  BONE DENSITOMETRY Lumbar Spine  The bone mineral density measures 0.86 gm/cm2. The T score measures -1.2. This indicates presence of osteopenia or low bone mass. There is no significant interval change seen in comparison with previous study done on August 2011.";

            ResizeNodeHeight(ultraTree1.Nodes[0].Nodes[0]);
            ultraTree1.ExpandAll();
        }

        private void ResizeNodeHeight(UltraTreeNode node)
        {
            UltraTreeNodeColumn col = node.Override.ColumnSet.Columns[2];

            // this is just a guess at the TextFormatFlags since I don't know what flags the control uses to render the text - maybe the right combination here would make a difference?
            // I've tried several with no success
            TextFormatFlags flags = TextFormatFlags.TextBoxControl | TextFormatFlags.WordBreak;
            Graphics g = ultraTree1.CreateGraphics();
            int width = col.LayoutInfo.PreferredCellSize.Width;
            Size maxSize = new Size(width, Int32.MaxValue); // I've tried passing 0 here as the height instead of MaxValue, but doesn't seem to make a difference
            Size textSize = System.Windows.Forms.TextRenderer.MeasureText(g, node.Cells[col].Text, node.Control.Font, maxSize, flags);
            int height = (int)Math.Ceiling(textSize.Height * g.DpiY / 72);
            col.LayoutInfo.PreferredCellSize = new Size(width, height);
        }

        private void ultraTree1_AfterNodeLayoutItemResize(object sender, AfterNodeLayoutItemResizeEventArgs e)
        {
            ResizeNodeHeight(ultraTree1.Nodes[0].Nodes[0]);
        }
    }
}
